<?php
$ROOT=dirname(dirname(dirname(__FILE__)));

$date = date("Y-m-d H:i:s"); 
$hostname=gethostname(); 

try {
    $db = new PDO("sqlite:$ROOT/dbf/nettemp.db");
    $db->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);
} catch (Exception $e) {
    echo $date." Could not connect to the database.\n";
    exit;
}
try {
    $sth = $db->query("SELECT * FROM nt_settings");
	$sth->execute();
	$result = $sth->fetchAll();
	foreach ($result as $a) {
		if($a['option']=='inflip') {
			$influxdb_ip=$a['value'];
		}
		if($a['option']=='inflport') {
			$influxdb_port=$a['value'];
		}
		if($a['option']=='inflon') {
			$influxdb_on=$a['value'];
		}
		if($a['option']=='inflbase') {
			$influxdb_base=$a['value'];
		}

	}
    
    if(!empty($influxdb_ip)&&!empty($influxdb_port)&&!empty($influxdb_base)&&$influxdb_on=='on'){
		
		require $ROOT."/other/composer/vendor/autoload.php";
		
		$client = new InfluxDB\Client($influxdb_ip, $influxdb_port);
		$database = $client->selectDB($influxdb_base);
		
		$query = $db->query("SELECT * FROM sensors WHERE influxdb='on'");
		$result = $query->fetchAll();

		$arraycounters = array("gas", "water", "elec", "elecesp");		
		
		foreach($result as $s) {

			$id=intval($s['id']);
			$time=strtotime($s['time']);
			$name=$s['name'];
			$value=floatval($s['tmp']);
			$type=$s['type'];
			$current=floatval($s['current']);
			$to_send = false;
			
			//zapytanie do bazy influx o dany sensor
			$inflquery = $db->query("SELECT * FROM influxdb WHERE id='$id'");
			$inflresult = $inflquery->fetch();
			if(! $inflresult){
				$db->exec("INSERT INTO influxdb (id,name,sent_value) VALUES ('$id','$name','$value' )") or die ("cannot insert to influxdb\n" );	
    			$to_send = true;
			}
			else{
				$db->exec("UPDATE influxdb SET sent_value='$value', time='$date'  WHERE id='$id'") or die ("cannot update to influxdb\n" );
				if(in_array($type, $arraycounters)) {
					if(strtotime($inflresult['time'])<=$time){  //czujnik doszedł po porzednim wysyłaniu
						$to_send = true;
					}
				}
				else{ 
					if(floatval($inflresult['sent_value'])!=$value) { // dodać czujnik zmienił wartość lub nie był wysyłany co najmniej 15 min
						$to_send = true;
					}
				}	
			}			
			
			if ($to_send == true){
				$points = [
                    new InfluxDB\Point(
                        'nt_'.$type, // the name of the measurement
                        $value, // measurement value
                        ['name' => $name], // measurement tags
                        ['current' => $current], // additional measurement fields
                        exec('date +%s%N') // timestamp in nanoseconds on Linux ONLY
                    )
                ];
         
         $toinflux = $database->writePoints($points);
			$to_send = false;
			echo $name." to influx\n";
			echo $toinflux;

			}
		}
    }

} catch (Exception $e) {
    echo $date." Error.\n";
    echo $e;
    exit;
}
?>

